Index: /extensions/AMetaData/JpegMetaData/Common/Locale.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/Common/Locale.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/Common/Locale.class.php	(revision 4698)
@@ -35,6 +35,38 @@
  * The Locale class is used for tag translation, reading the .mo files
  *
+ * There is one directory per language, the directories tree must respect this
+ * structure
+ *
+ * --\ Locale                           => main directory for languages
+ *     |
+ *     +--\ en_UK                       => language
+ *     |    |
+ *     |    +--\ LC_MESSAGES
+ *     |         |
+ *     |         +--\ Tag.mo            => names & values translations
+ *     |         +--\ TadDesc.mo        => descriptions translations
+ *     |
+ *     +--\ fr_FR
+ *          |
+ *          +--\ LC_MESSAGES
+ *               |
+ *               +--\ Tag.mo
+ *               +--\ TadDesc.mo
+ *
+ *
  * -----------------------------------------------------------------------------
  *
+ * .. Notes ..
+ *
+ * This class don't use the PHP gettext functions, but the php-gettext extension
+ * ==> See files in External/php-gettext for more information about this project
+ *
+ *
+ *
+ * This class provides theses public functions :
+ *  - (static) setLanguage
+ *  - (static) getLanguage
+ *  - (static) get
+ *  - (static) getDesc
  *
  * -----------------------------------------------------------------------------
@@ -44,5 +76,15 @@
 require_once(JPEG_METADATA_DIR."External/php-gettext/gettext.inc");
 
-$supported_locales = array('en_UK');
+/**
+ * $supported_locales is a global variable need by the php-gettext package.
+ * the array is automatically initialized with the setLanguage() function
+ */
+$supported_locales = array();
+
+/**
+ * assume a default language is set in any case...
+ */
+Locale::setLanguage();
+
 
 class Locale
@@ -51,17 +93,85 @@
   const JMD_TAGDESC = "TagDesc";
 
-  static function set($language)
+  static private $language = "";
+
+  /**
+   * This function is used to set the locale language.
+   * If no language is given, assume the default "en_UK" language
+   *
+   * If there is no translation file for the the given language, assume the
+   * default "en_UK" language
+   *
+   * @param String $language : the language
+   * @return String : the defined language
+   */
+  static function setLanguage($language="en_UK")
   {
-    T_setlocale(LC_MESSAGES, $language);
+    global $supported_locales;
 
+    /*
+     * Scan the Locale directory.
+     * Any directory with a sub directory "LC_MESSAGES" is considered as a
+     * supported locale language
+     */
+    $directory=scandir(JPEG_METADATA_DIR."Locale");
+    foreach($directory as $key => $file)
+    {
+      if(is_dir(JPEG_METADATA_DIR."Locale/".$file) and
+         $file!='.' and
+         $file!='..' and
+         file_exists(JPEG_METADATA_DIR."Locale/".$file."/LC_MESSAGES/Tag.mo"))
+         $supported_locales[]=$file;
+
+    }
+
+    /*
+     * if the desired language doesn't exist, apply the en_UK locale
+     * (assuming the en_UK exists and was not deleted)
+     */
+    if(!in_array($language, $supported_locales))
+      self::$language='en_UK';
+    else
+      self::$language=$language;
+
+    /*
+     * set the locale
+     */
+    T_setlocale(LC_MESSAGES, self::$language);
+
+    /*
+     * set one domain "TAG" for tags name&values, and one domaine "TAGDESC" for
+     * tags description
+     */
     T_bindtextdomain(self::JMD_TAG, dirname(dirname(__FILE__))."/Locale");
     T_bindtextdomain(self::JMD_TAGDESC, dirname(dirname(__FILE__))."/Locale");
+
+    return(self::$language);
   }
 
-  static function get($tagName)
+  /**
+   * returns the defined current language
+   *
+   * @return String
+   */
+  static function getLanguage()
   {
-    return(@T_dgettext(self::JMD_TAG, $tagName));
+    return(self::$language);
   }
 
+  /**
+   * returns the translation in current language for the given key
+   *
+   * @return String
+   */
+  static function get($key)
+  {
+    return(@T_dgettext(self::JMD_TAG, $key));
+  }
+
+  /**
+   * returns the description in current language for the given tagName
+   *
+   * @return String
+   */
   static function getDesc($tagName)
   {
Index: /extensions/AMetaData/JpegMetaData/Common/Tag.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/Common/Tag.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/Common/Tag.class.php	(revision 4698)
@@ -58,16 +58,16 @@
  *  - getValue
  *  - getLabel
- *  - getIsKnown
- *  - getIsImplemented
  *  - getNote
- *  - getIsTranslatable
+ *  - isKnown
+ *  - isImplemented
+ *  - isTranslatable
  *  - setId
  *  - setName
  *  - setValue
  *  - setLabel
- *  - setIsKnown
- *  - setIsImplemented
  *  - setNote
- *  - setIsTranslatable
+ *  - setKnown
+ *  - setImplemented
+ *  - setTranslatable
  *
  * -----------------------------------------------------------------------------
@@ -164,5 +164,5 @@
      * @return Boolean
      */
-    public function getIsKnown()
+    public function isKnown()
     {
       return($this->tagIsKnown);
@@ -174,5 +174,5 @@
      * @return Boolean
      */
-    public function getIsImplemented()
+    public function isImplemented()
     {
       return($this->tagIsImplemented);
@@ -194,5 +194,5 @@
      * @return Boolean
      */
-    public function getIsTranslatable()
+    public function isTranslatable()
     {
       return($this->tagIsTranslatable);
@@ -207,5 +207,5 @@
     public function setId($value)
     {
-      if($value>=0x0000 and $value <= 0xffff) $this->tagId=$value;
+      $this->tagId=$value;
       return($this->tagId);
     }
@@ -253,5 +253,5 @@
      * @return Boolean
      */
-    public function setIsKnown($value)
+    public function setKnown($value)
     {
       $this->tagIsKnown=($value===true)?true:false;
@@ -265,5 +265,5 @@
      * @return Boolean
      */
-    public function setIsImplemented($value)
+    public function setImplemented($value)
     {
       $this->tagIsImplemented=($value===true)?true:false;
@@ -289,5 +289,5 @@
      * @return Boolean
      */
-    public function setIsTranslatable($value)
+    public function setTranslatable($value)
     {
       $this->tagIsTranslatable=($value===true)?true:false;
Index: /extensions/AMetaData/JpegMetaData/JpegMetaData.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/JpegMetaData.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/JpegMetaData.class.php	(revision 4698)
@@ -433,5 +433,5 @@
       foreach($this->tags as $key => $val)
       {
-        if(self::filter($val->getIsKnown(), $val->getIsImplemented(), $tagFilter))
+        if(self::filter($val->isKnown(), $val->isImplemented(), $tagFilter))
         {
           $returned[$key]=$val;
@@ -477,5 +477,5 @@
       foreach($ifd->getTags() as $key => $tag)
       {
-        if(self::filter($tag->getTag()->getIsKnown(), $tag->getTag()->getIsImplemented(), $this->options['filter']))
+        if(self::filter($tag->getTag()->isKnown(), $tag->getTag()->isImplemented(), $this->options['filter']))
         {
           if($tag->getTag()->getLabel() instanceof IfdReader)
@@ -519,5 +519,5 @@
       foreach($tags as $key => $tag)
       {
-        if(self::filter($tag->getIsKnown(), $tag->getIsImplemented(), $this->options['filter']))
+        if(self::filter($tag->isKnown(), $tag->isImplemented(), $this->options['filter']))
         {
           $this->tags[$tagKey.".".$tag->getName()]=$tag;
Index: /extensions/AMetaData/JpegMetaData/Readers/GenericReader.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/Readers/GenericReader.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/Readers/GenericReader.class.php	(revision 4698)
@@ -111,4 +111,5 @@
     /**
      * returns a Tag object from a sequential index
+     * return null if index is out of range
      *
      * @return Tag
@@ -116,5 +117,8 @@
     public function getTag($index)
     {
-      return($this->entries[$index]);
+      if($index>=0 and $index<=count($this->entries))
+        return($this->entries[$index]);
+      else
+        return(null);
     }
 
@@ -140,7 +144,17 @@
       for($i=0;$i<count($this->entries);$i++)
       {
-        if($this->entries[$i]->getId()==$tagId)
-        {
-          return($i);
+        if($this->entries[$i] instanceof IfdEntryReader)
+        {
+          if($this->entries[$i]->getTagId()==$tagId)
+          {
+            return($i);
+          }
+        }
+        elseif($this->entries[$i] instanceof Tag)
+        {
+          if($this->entries[$i]->getId()==$tagId)
+          {
+            return($i);
+          }
         }
       }
@@ -176,7 +190,17 @@
       for($i=0;$i<count($this->entries);$i++)
       {
-        if($this->entries[$i]->getName()==$name)
-        {
-          return($this->entries[$i]);
+        if($this->entries[$i] instanceof IfdEntryReader)
+        {
+          if($this->entries[$i]->getTag()->getName()==$name)
+          {
+            return($this->entries[$i]->getTag());
+          }
+        }
+        elseif($this->entries[$i] instanceof Tag)
+        {
+          if($this->entries[$i]->getName()==$name)
+          {
+            return($this->entries[$i]);
+          }
         }
       }
Index: /extensions/AMetaData/JpegMetaData/Readers/HeightBIMReader.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/Readers/HeightBIMReader.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/Readers/HeightBIMReader.class.php	(revision 4698)
@@ -55,4 +55,5 @@
  *  - getSize
  *  - getBlockSize
+ *  - getName
  *
  * -----------------------------------------------------------------------------
Index: /extensions/AMetaData/JpegMetaData/Readers/IfdReader.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/Readers/IfdReader.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/Readers/IfdReader.class.php	(revision 4698)
@@ -219,8 +219,8 @@
         $tag=$this->tagDef->getTagById($entry->getTagId());
 
-        $entry->getTag()->setIsKnown(true);
+        $entry->getTag()->setKnown(true);
         $entry->getTag()->setName($tag['tagName']);
-        $entry->getTag()->setIsImplemented($tag['implemented']);
-        $entry->getTag()->setIsTranslatable($tag['translatable']);
+        $entry->getTag()->setImplemented($tag['implemented']);
+        $entry->getTag()->setTranslatable($tag['translatable']);
 
         /*
Index: /extensions/AMetaData/JpegMetaData/Readers/IptcReader.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/Readers/IptcReader.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/Readers/IptcReader.class.php	(revision 4698)
@@ -220,8 +220,8 @@
         $tagProperties=$this->tagDef->getTagById($tag->getId());
 
-        $tag->setIsKnown(true);
+        $tag->setKnown(true);
         $tag->setName($tagProperties['tagName']);
-        $tag->setIsImplemented($tagProperties['implemented']);
-        $tag->setIsTranslatable($tagProperties['translatable']);
+        $tag->setImplemented($tagProperties['implemented']);
+        $tag->setTranslatable($tagProperties['translatable']);
 
         /*
Index: /extensions/AMetaData/JpegMetaData/Readers/MakerNotesReader.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/Readers/MakerNotesReader.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/Readers/MakerNotesReader.class.php	(revision 4698)
@@ -33,6 +33,13 @@
  * -----------------------------------------------------------------------------
  *
- * The MakerNotesReader class is dedicated to read tags from the maker note sub
- * IFD structure
+ * The exif tag 0x927C "MakerNote" is a tag used by the camera maker to manage
+ * their own data.
+ *
+ * In most of case, this tags gives an offset to an extra data block.
+ * And in most of case, this data block is a sub-IFD block
+ *
+ * The MakerNotesReader is a generic class dedicated to read tags from the maker
+ * note sub IFD structure
+ *
  *
  * ======> See IfdReader.class.php to know more about an IFD structure <========
Index: /extensions/AMetaData/JpegMetaData/Readers/PentaxReader.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/Readers/PentaxReader.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/Readers/PentaxReader.class.php	(revision 4698)
@@ -9,11 +9,46 @@
  *   << May the Little SpaceFrog be with you ! >>
  *
+ *
+ * +-----------------------------------------------------------------------+
+ * | JpegMetaData - a PHP based Jpeg Metadata manager                      |
+ * +-----------------------------------------------------------------------+
+ * | Copyright(C) 2010  Grum - http://www.grum.fr                          |
+ * +-----------------------------------------------------------------------+
+ * | This program is free software; you can redistribute it and/or modify  |
+ * | it under the terms of the GNU General Public License as published by  |
+ * | the Free Software Foundation                                          |
+ * |                                                                       |
+ * | This program is distributed in the hope that it will be useful, but   |
+ * | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+ * | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+ * | General Public License for more details.                              |
+ * |                                                                       |
+ * | You should have received a copy of the GNU General Public License     |
+ * | along with this program; if not, write to the Free Software           |
+ * | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+ * | USA.                                                                  |
+ * +-----------------------------------------------------------------------+
+ *
+ *
  * -----------------------------------------------------------------------------
  *
+ * The PentaxReader class is the dedicated to read the specific Pentax tags
+ *
+ * ====> See MakerNotesReader.class.php to know more about the structure <======
+ *
  * -----------------------------------------------------------------------------
- * Pentax reader class
+ *
+ * .. Notes ..
+ *
+ *
+ * The PentaxReader class is derived from the MakerNotesReader class.
+ *
+ * ======> See MakerNotesReader.class.php to know more about common methods <======
+ *
  * -----------------------------------------------------------------------------
  */
 
+
+
   require_once(JPEG_METADATA_DIR."TagDefinitions/PentaxTags.class.php");
   require_once(JPEG_METADATA_DIR."Readers/MakerNotesReader.class.php");
@@ -21,4 +56,21 @@
   class PentaxReader extends MakerNotesReader
   {
+    /**
+     * The constructor needs, like the ancestor, the datas to be parsed
+     *
+     * Some datas are offset on extra data, and this offset can be (some time)
+     * absolute inside the IFD, or relative. So, the offset of the IFD structure
+     * is needed
+     *
+     * The byte order can be different from the TIFF byte order !
+     *
+     * The constructor need the maker signature (see the MakerNotesSignatures
+     * class for a list of known signatures)
+     *
+     * @param String $data
+     * @param ULong $offset : offset of IFD block in the jpeg file
+     * @param String $byteOrder
+     * @param String $makerSignature :
+     */
     function __construct($data, $offset, $byteOrder, $makerSignature)
     {
@@ -39,4 +91,8 @@
     }
 
+
+    /**
+     * initialize the definition for Pentax exif tags
+     */
     protected function initializeTagDef()
     {
@@ -44,4 +100,7 @@
     }
 
+    /**
+     * skip the IFD header
+     */
     protected function skipHeader($headerSize=0)
     {
@@ -49,4 +108,15 @@
     }
 
+    /**
+     * this function do the interpretation of specials tags
+     *
+     * the function return the interpreted value for the tag
+     *
+     * @param $tagId             : the id of the tag
+     * @param $values            : 'raw' value to be interpreted
+     * @param UByte $type        : if needed (for IFD structure) the type of data
+     * @param ULong $valueOffset : if needed, the offset of data in the jpeg file
+     * @return String or Array or DateTime or Integer or Float...
+     */
     protected function processSpecialTag($tagId, $values, $type, $valuesOffset=0)
     {
@@ -172,4 +242,10 @@
           $returned=53190 -$values;
           break;
+
+        /* theses tags decoding is not yet implemented
+         * have to take a look on the algorithm in exiftool (it seems to work
+         * but I don't understand everything...)
+         */
+
         case 0x0205: // "ShotInfo",
         case 0x0206: // "AEInfo",
@@ -192,8 +268,4 @@
         case 0x0222: // "ColorInfo",
 
-        /* theses tags decoding is not yet implemented
-         * have to take a look on the algorithm in exiftool (it seems to work
-         * but I don't understand everything...)
-         */
         case 0x0029: // "FrameNumber",
         case 0x0041: // "DigitalFilter",
@@ -207,12 +279,8 @@
           $returned="Not yet implemented;".ConvertData::toHexDump($tagId, ByteType::USHORT)." => ".ConvertData::toHexDump($values, $type);
           break;
-
       }
-
       return($returned);
     }
-
   }
 
-
 ?>
Index: /extensions/AMetaData/JpegMetaData/Readers/SegmentReader.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/Readers/SegmentReader.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/Readers/SegmentReader.class.php	(revision 4698)
@@ -9,8 +9,45 @@
  *   << May the Little SpaceFrog be with you ! >>
  *
- * -----------------------------------------------------------------------------
+ *
+ * +-----------------------------------------------------------------------+
+ * | JpegMetaData - a PHP based Jpeg Metadata manager                      |
+ * +-----------------------------------------------------------------------+
+ * | Copyright(C) 2010  Grum - http://www.grum.fr                          |
+ * +-----------------------------------------------------------------------+
+ * | This program is free software; you can redistribute it and/or modify  |
+ * | it under the terms of the GNU General Public License as published by  |
+ * | the Free Software Foundation                                          |
+ * |                                                                       |
+ * | This program is distributed in the hope that it will be useful, but   |
+ * | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+ * | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+ * | General Public License for more details.                              |
+ * |                                                                       |
+ * | You should have received a copy of the GNU General Public License     |
+ * | along with this program; if not, write to the Free Software           |
+ * | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+ * | USA.                                                                  |
+ * +-----------------------------------------------------------------------+
  *
  *
  * -----------------------------------------------------------------------------
+ *
+ * The SegmentReader is a generic class providing methods to manage datas
+ * segments
+ *
+ * -----------------------------------------------------------------------------
+ *
+ * .. Notes ..
+ *
+ * This class is not declared as an abstract class, but it's not recommanded to
+ * create object with it.
+ *
+ *
+ * Derived classes :
+ *  - TiffReader        (for Tiff data block)
+ *
+ * This class provides theses public functions :
+ *  - getIsValid
+ *  - getIsLoaded
  *
  * -----------------------------------------------------------------------------
@@ -23,4 +60,9 @@
     protected $isLoaded = false;
 
+    /**
+     * The constructor need the segment's datas
+     *
+     * @param Data $data : a Data object
+     */
     function __construct(Data $data)
     {
@@ -29,4 +71,9 @@
     }
 
+    /**
+     * return true if the segment is valid
+     *
+     * @return Boolean
+     */
     public function getIsValid()
     {
@@ -34,4 +81,9 @@
     }
 
+    /**
+     * return true if the segment is loaded
+     *
+     * @return Boolean
+     */
     public function getIsLoaded()
     {
Index: /extensions/AMetaData/JpegMetaData/Readers/TiffReader.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/Readers/TiffReader.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/Readers/TiffReader.class.php	(revision 4698)
@@ -9,11 +9,56 @@
  *   << May the Little SpaceFrog be with you ! >>
  *
- * -----------------------------------------------------------------------------
+ *
+ * +-----------------------------------------------------------------------+
+ * | JpegMetaData - a PHP based Jpeg Metadata manager                      |
+ * +-----------------------------------------------------------------------+
+ * | Copyright(C) 2010  Grum - http://www.grum.fr                          |
+ * +-----------------------------------------------------------------------+
+ * | This program is free software; you can redistribute it and/or modify  |
+ * | it under the terms of the GNU General Public License as published by  |
+ * | the Free Software Foundation                                          |
+ * |                                                                       |
+ * | This program is distributed in the hope that it will be useful, but   |
+ * | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+ * | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+ * | General Public License for more details.                              |
+ * |                                                                       |
+ * | You should have received a copy of the GNU General Public License     |
+ * | along with this program; if not, write to the Free Software           |
+ * | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+ * | USA.                                                                  |
+ * +-----------------------------------------------------------------------+
  *
  *
  * -----------------------------------------------------------------------------
  *
+ * The TiffReader class is the dedicated to read a TIFF structure
+ *
+ * A Tiff structure is formatted as this :
+ *  - byte order            : 2 bytes, "II" or "MM", indicates the byte order
+ *  - header tag            : 2 bytes, UShort equals 0x002a
+ *  - first IFD offset      : 4 bytes, ULong
+ *  - IFDs                  :
+ *
+ * => See IfdReader.class.php & IfdEntryReader.class.php to know more on IFD <==
+ *
+ * -----------------------------------------------------------------------------
+ *
+ * .. Notes ..
+ *
+ *
+ * The TiffReader class is derived from the SegmentReader class.
+ *
+ * ======> See SegmentReader.class.php to know more about common methods <======
+ *
+ *
+ * This class provides theses public functions :
+ *  - getNbIFDs
+ *  - getIFDs
+ *  - getIFD
+ *
  * -----------------------------------------------------------------------------
  */
+
 
   require_once(JPEG_METADATA_DIR."Common/ConvertData.class.php");
@@ -29,4 +74,11 @@
     private $firstIFDOffset = 0;
 
+    /**
+     * The constructor need the Tiff block datas (given as a Data object) and
+     * offset of the TIFF block inside the jpeg file
+     *
+     * @param Data $data :
+     * @param ULong $offsetData (optional) :
+     */
     function __construct(Data $data, $offsetData=0)
     {
@@ -48,5 +100,5 @@
 
         $header=$this->data->readUShort();
-        if($header==0x2a)
+        if($header==0x002a)
         {
           $this->isValid=true;
@@ -62,16 +114,9 @@
     }
 
-    private function readData()
-    {
-      $nextIFD = $this->firstIFDOffset;
-      while($nextIFD!=0)
-      {
-        $this->data->seek($nextIFD);
-        $IFD = new IfdReader($this->data->readASCII(), $nextIFD, $this->byteOrder);
-        $this->IFDs[]=$IFD;
-        $nextIFD = $IFD->getNextIFDOffset();
-      }
-    }
-
+    /**
+     * return the number of IFDs found in the Tiff block
+     *
+     * @return Integer
+     */
     public function getNbIFDs()
     {
@@ -79,4 +124,9 @@
     }
 
+    /**
+     * return an array of IFD found in the the Tiff block
+     *
+     * @return IFD[]
+     */
     public function getIFDs()
     {
@@ -84,4 +134,10 @@
     }
 
+    /**
+     * returns a specific IFD
+     *
+     * @param Integer $num : index of the needed IFD
+     * @return IFD
+     */
     public function getIFD($num)
     {
@@ -91,5 +147,4 @@
         return(null);
     }
-
 
     public function toString()
@@ -104,4 +159,25 @@
     }
 
+    /**
+     * The readData function read IFDs from the Tiff block, and add them into
+     * the IFDs array
+     */
+    private function readData()
+    {
+      $nextIFD = $this->firstIFDOffset;
+      /*
+       * while the next IFD offset is not zero, read the IFD at the designed
+       * offset
+       *
+       * the next IFD offset is given at the end of the last IFD read.
+       */
+      while($nextIFD!=0)
+      {
+        $this->data->seek($nextIFD);
+        $IFD = new IfdReader($this->data->readASCII(), $nextIFD, $this->byteOrder);
+        $this->IFDs[]=$IFD;
+        $nextIFD = $IFD->getNextIFDOffset();
+      }
+    }
   }
 
Index: /extensions/AMetaData/JpegMetaData/Readers/XmpReader.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/Readers/XmpReader.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/Readers/XmpReader.class.php	(revision 4698)
@@ -295,7 +295,7 @@
         $tagProperties=$this->tagDef->getTagById($name);
 
-        $tag->setIsKnown(true);
-        $tag->setIsImplemented($tagProperties['implemented']);
-        $tag->setIsTranslatable($tagProperties['translatable']);
+        $tag->setKnown(true);
+        $tag->setImplemented($tagProperties['implemented']);
+        $tag->setTranslatable($tagProperties['translatable']);
 
 
Index: /extensions/AMetaData/JpegMetaData/TagDefinitions/GpsTags.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/TagDefinitions/GpsTags.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/TagDefinitions/GpsTags.class.php	(revision 4698)
@@ -10,7 +10,37 @@
  *
  *
+ * +-----------------------------------------------------------------------+
+ * | JpegMetaData - a PHP based Jpeg Metadata manager                      |
+ * +-----------------------------------------------------------------------+
+ * | Copyright(C) 2010  Grum - http://www.grum.fr                          |
+ * +-----------------------------------------------------------------------+
+ * | This program is free software; you can redistribute it and/or modify  |
+ * | it under the terms of the GNU General Public License as published by  |
+ * | the Free Software Foundation                                          |
+ * |                                                                       |
+ * | This program is distributed in the hope that it will be useful, but   |
+ * | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+ * | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+ * | General Public License for more details.                              |
+ * |                                                                       |
+ * | You should have received a copy of the GNU General Public License     |
+ * | along with this program; if not, write to the Free Software           |
+ * | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+ * | USA.                                                                  |
+ * +-----------------------------------------------------------------------+
+ *
+ *
  * -----------------------------------------------------------------------------
- * Known IFD tags properties class
+ *
+ * The GpsTags is the definition of the Gps Exif tags
+ *
  * -----------------------------------------------------------------------------
+ *
+ * .. Notes ..
+ *
+ * The GpsTags class is derived from the KnownTags class.
+ *
+ * ======> See KnownTags.class.php to know more about the tag definitions <=====
+ *
  */
 
Index: /extensions/AMetaData/JpegMetaData/TagDefinitions/IfdTags.class.php
===================================================================
--- /extensions/AMetaData/JpegMetaData/TagDefinitions/IfdTags.class.php	(revision 4697)
+++ /extensions/AMetaData/JpegMetaData/TagDefinitions/IfdTags.class.php	(revision 4698)
@@ -10,7 +10,37 @@
  *
  *
+ * +-----------------------------------------------------------------------+
+ * | JpegMetaData - a PHP based Jpeg Metadata manager                      |
+ * +-----------------------------------------------------------------------+
+ * | Copyright(C) 2010  Grum - http://www.grum.fr                          |
+ * +-----------------------------------------------------------------------+
+ * | This program is free software; you can redistribute it and/or modify  |
+ * | it under the terms of the GNU General Public License as published by  |
+ * | the Free Software Foundation                                          |
+ * |                                                                       |
+ * | This program is distributed in the hope that it will be useful, but   |
+ * | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+ * | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+ * | General Public License for more details.                              |
+ * |                                                                       |
+ * | You should have received a copy of the GNU General Public License     |
+ * | along with this program; if not, write to the Free Software           |
+ * | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+ * | USA.                                                                  |
+ * +-----------------------------------------------------------------------+
+ *
+ *
  * -----------------------------------------------------------------------------
- * Known IFD tags properties class
+ *
+ * The IfdTags is the definition of the Tiff & Exif tags
+ *
  * -----------------------------------------------------------------------------
+ *
+ * .. Notes ..
+ *
+ * The IfdTags class is derived from the KnownTags class.
+ *
+ * ======> See KnownTags.class.php to know more about the tag definitions <=====
+ *
  */
 
